/*
*Dieses Programm wurde im Rahmen des Praktikums Paralleles Programmieren 
*geschrieben. Es implementiert einen Algorithmus zum Lsen von Mastermind,
*der abstrakt von Donald E. Knuth beschrieben wurde.
*Dieses Programm wurde mit MPI parallelisiert.
*Gestartet wird das Programm zur Zeit ohne Parameter.
*Autoren sind Nicole Tnzer und Fabian Fiedler
*/
#include "mpi.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define ARRAY_SIZE 1296


int bewerte(int*,int*,int*);
int erstelleListe(int**);
int Loeser(int*, int*);
int entferne(int**, int* , int* );
int istSchwarzMoeglich(int, int**, int**);
int bewerteMitfolgendemErgebnis( int, int, int, int**,int**);
int berechnenaechstenTipp(int**, int**,int*, int*);
int empfangeNachrichten();
int sendeNachrichten(int,int);

/*
* Die Main Methode startet das Berechnen. Man bentigt keine Parameter.
* 
*/
int main(int argc, char *Eingabe[])
{
  clock_t prgstart, prgende;
	prgstart=clock();
  int rank, size;
  MPI_Init (&argc, &Eingabe);
  MPI_Comm_rank (MPI_COMM_WORLD, &rank); 
  MPI_Comm_size (MPI_COMM_WORLD, &size);

    if ((size <= 1) & (size > ARRAY_SIZE))
    {
      if(rank == 0)
      {
      printf("Bitte mit mindestens 2 und hoechsten %d Kernen starten", ARRAY_SIZE);
      }
      MPI_Finalize();
      return 0;
    }

  if(rank==0)
  {
    sendeNachrichten(rank,size);
      prgende=clock();
      printf("Laufzeit %.2f Sekunden\n",(float)(prgende-prgstart) / CLOCKS_PER_SEC);
  	printf("Anzahl %d",size);
	}
  else
    {
    empfangeNachrichten();
    }
    MPI_Finalize();
    return 0;
}


//Wird vom Prozess 0 aufgerufen und sorgt fr die Verteilung und danach fr die 
Auswertung der Ergebnisse
int sendeNachrichten(int rank, int size)
{
  int *liste;
    liste = malloc(ARRAY_SIZE * sizeof(int));
  MPI_Request request[size];
  MPI_Request send[ARRAY_SIZE];
  int **AlleErgebnisse;
    AlleErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));
  int k;
  for (k=0;k< ARRAY_SIZE;k++)
    {AlleErgebnisse[k]=malloc(4*sizeof(int));}
  erstelleListe(AlleErgebnisse);
  int i = 0;
  int dest=1;
  int erg[size][6];
  printf("Dieses Programm wurde im Rahmen des Praktikums Paralleles 
Programmieren geschrieben. Es implementiert einen Algorithmus zum Lsen von 
Mastermind, der Abstrakt von Donald E. Knuth beschrieben wurde. Autoren sind 
Nicole Tnzer und Fabian Fiedler");

  //Verteilt die erste Ladung an Auftrgen
  for(dest = 1; dest < size;dest++)
   {
    MPI_Isend(&i, 1, MPI_INT,dest,0, MPI_COMM_WORLD,&send[i]);
    MPI_Irecv(&erg[dest][0], 6, MPI_INT,dest,0, MPI_COMM_WORLD,&request[i]);
    i++;
    }
  //Verteilt die Restlichen sobald jemand fertig ist.
  while(i < ARRAY_SIZE)
  {
    MPI_Status status;
    int index;
    MPI_Waitany(size-1,request,&index, &status);
    int ort= status.MPI_SOURCE;
   liste[erg[ort][5]]=erg[ort][4];
    MPI_Isend(&i, 1, MPI_INT,ort,0, MPI_COMM_WORLD,&send[i]);
    MPI_Irecv(&erg[ort][0], 6, MPI_INT,ort,0, MPI_COMM_WORLD,&request[ort]);
    i++;
  }

  
 MPI_Status status[size];
  //holt die anderen Nachrichten wieder ein
  MPI_Waitall(size-1,request,status);
  for(i=1; i < size; i++)
  {
    int ort= (status[i]).MPI_SOURCE;
    if(ort != -2)
    {
   liste[ (erg[ort][5]) ]=erg[ort][4];
    }
  } 

  //schliet die anderen Prozesse
  for(dest=0; dest < size; dest++)
  {
   int j = -1;
    MPI_Isend( &j, 1, MPI_INT,dest,0, MPI_COMM_WORLD, &request[dest]);
  }


  //Ausgabe der Ergebnisse auf der Konsole
  int d=0;
  int e = 0;
  for(k=1;k < 9;k++)
  {
    printf("\n Folgende Zahlen brauchen %d Versuche :\n", k );
    for(i= 0; i<ARRAY_SIZE;i++)
      {
      if(liste[i]==k)
      {
        e = e + k;
      d++;
      
printf("%d%d%d%d,",AlleErgebnisse[i][0],AlleErgebnisse[i][1],AlleErgebnisse[i][2],AlleE
rgebnisse[i][3]);
      }
      }
    printf("\n");
  } 
  printf("Durchschnittlich %f Versuche.", ((1.0 * e)/d));
return 0;
}


/**
* Diese Methode wird von den Workern aufgerufen, sie warten bis sie einen 
Aufgabenteil bekommen und rechnet diesen dann mithilfe des Lsers aus.
*/
int empfangeNachrichten()
{
    int **AlleErgebnisse;
    AlleErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));
    int k;
    for (k=0;k< ARRAY_SIZE;k++)
      {AlleErgebnisse[k]=malloc(4*sizeof(int));}
    erstelleListe(AlleErgebnisse);

  while(1)
  {
    int gesamterg[6];
    int Zeile;
    MPI_Recv(&Zeile, 1, MPI_INT, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

    if(Zeile == -1)
    {
      return 0;
    }

    int *erg;
      erg= malloc(6*sizeof(int));

    int a = Loeser(AlleErgebnisse[Zeile],erg);
    gesamterg[0] = erg[0];
    gesamterg[1] = erg[1];
    gesamterg[2] = erg[2];
    gesamterg[3] = erg[3];
    gesamterg[4] = a;
    gesamterg[5] = Zeile;
    MPI_Send(gesamterg, 6, MPI_INT,0,0, MPI_COMM_WORLD);
    free(erg);
  }
}


/**
* Versucht das Problem zu loesen, indem es Knuths Algorithmus anwendet. Benoetigt 
*die Loesung nur als Abbruchbedingung.
**/
int Loeser(int *loesung, int *erg)
{
  int **MoeglicheErgebnisse;
  MoeglicheErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));

  int i;
  for (i=0;i< ARRAY_SIZE;i++)
    {MoeglicheErgebnisse[i]=malloc(4*sizeof(int));}    
  erstelleListe(MoeglicheErgebnisse);

  int **AlleErgebnisse;
  AlleErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));

  int k;
  for (k=0;k< ARRAY_SIZE;k++)
    {AlleErgebnisse[k]=malloc(4*sizeof(int));}
  erstelleListe(AlleErgebnisse);

  int *bewertung;
    bewertung = (int *) calloc( 4, sizeof(int));

  int *naechsterTipp;
    naechsterTipp= (int *) malloc( 4 * sizeof(int));

  int *letzterTipp;
    letzterTipp = (int *) malloc( 4* sizeof(int));

  int anzahl=1;

  naechsterTipp[0]=0;
  naechsterTipp[1]=0;
  naechsterTipp[2]=1;
  naechsterTipp[3]=1;

  bewerte(loesung,naechsterTipp, bewertung);     

  //Die Abbruchbedingung, dass der Tipp Richtig ist.    
  while (bewertung[0] != 4)
    {
    entferne(MoeglicheErgebnisse,naechsterTipp, bewertung);    
    berechnenaechstenTipp(MoeglicheErgebnisse,AlleErgebnisse,bewertung,naechsterTipp);
    bewerte(loesung,naechsterTipp,bewertung);
    anzahl++;
    }

  erg[0]=naechsterTipp[0];
  erg[1]=naechsterTipp[1];
  erg[2]=naechsterTipp[2];
  erg[3]=naechsterTipp[3];


  free(bewertung);
  free(naechsterTipp);
  free(letzterTipp);
 for (i=0;i<ARRAY_SIZE;i++)
  {free(MoeglicheErgebnisse[i]);}

  for (i=0;i<ARRAY_SIZE;i++)
    {free(AlleErgebnisse[i]);}

  free(MoeglicheErgebnisse);
  free(AlleErgebnisse);
  return anzahl;
}


/**
 *Berechnet die Anzahl weisser und schwarzer Stifte der Eingabe im Vergleich zum Loesungsvorschlag
 **/
int bewerte(int *eingabe,int *loesungsVorschlag, int *erg)
{
  int schwarz=0;
  int weiss=0;
  int i;
  int Temp[4];

  for(i=0; i <=3; i++)
   {Temp[i]=eingabe[i];}

  for(i=0; i <= 3; i++)
  {
   if(Temp[i]==loesungsVorschlag[i])
   {
      schwarz = schwarz + 1;
      Temp[i] = -1;
   }

   int k;
   for(k = 0; k <= 3; k++)
   {
    if((k != i) & (Temp[i]==loesungsVorschlag[k]))
      {
      weiss = weiss +1;
      break;
      }
    }
  }
  erg[0]=schwarz;
  erg[1]=weiss;
  return 0 ;
}


/**
* Erstellt die Liste aller moeglichen Ergebnisse.
**/
int erstelleListe(int **MoeglicheErgebnisse)
{
  int i;
  for(i = 0; i<6;i++)
    {
    int k;
    for(k = 0; k <6; k++)
      {
      int j;
      for( j = 0; j <6; j++)
        {
        int m;
        for( m = 0; m <6; m++)
        {
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][0]=m;
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][1]=j;
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][2]=k;
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][3]=i;
          }
        }
      }
    }
  return 0;
}


/**
* Entfernt alle nicht mehr mglichen Codes, Berechnung siehe Praktikumsbericht.
**/
int entferne(int **Set, int *Tipp, int *bewTipp)
{
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
    {
      int *bewertung;
      bewertung = malloc(2*sizeof(int));
      bewerte(Set[i], Tipp ,bewertung);

      if((bewertung[0] != bewTipp[0]) | (bewertung[1] != bewTipp[1]))
        {
        Set[i][0]= -1;
        }

      free(bewertung);
    } 
  return 0;
}


/*
* Diese Methode berechnet den nchsten Tipp, nach Knuth. Zum verstehen der 
* Strategie weisen wir auf die Arbeit im J. Recreational Mathematics,
* Vol. 9(1), 1976/77: The Computer as Mastermind, Donald Knuth hin.
*/
 int berechnenaechstenTipp(int **Set, int **AlleMoeglichkeiten,int 
*bewertungLetzterTipp, int *erg)
{
  int gesamterScore=0;
  int ortgesamterScore=0;
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
   {
    int minScore = ARRAY_SIZE;
    int w;
    for(w=0; w <= 4; w++)
      {
      int s;
      for(s = 0; s <= 4; s++)
        {
        if( (w + s) > 4) {break;}
        int score = bewerteMitfolgendemErgebnis(i,w,s,Set,AlleMoeglichkeiten);
        if(score < minScore)
          {
          minScore = score;
          }
        }
      }
    if((minScore > gesamterScore) | ( (minScore == gesamterScore )& ( 
istSchwarzMoeglich(i,Set,AlleMoeglichkeiten) == 1)))
      {
      gesamterScore=minScore;
      ortgesamterScore=i;
      }
  }

  erg[0] = AlleMoeglichkeiten[ortgesamterScore][0];
  erg[1] = AlleMoeglichkeiten[ortgesamterScore][1];
  erg[2] = AlleMoeglichkeiten[ortgesamterScore][2];
  erg[3] = AlleMoeglichkeiten[ortgesamterScore][3];
  return 0;
}


/*
* Diese Methode berprft ob ein gewisser Tipp richtig sein kann. Dies wird 
* bentigt, da bei zwei gleich guten Tipps derjenige der schwarz sein kann 
* bevorzugt wird.
*/
int istSchwarzMoeglich(int ort, int **Set, int **AlleMoeglichkeiten)
{
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
    {
    if(Set[i][0] != -1)
      {
      int *bewertung;
        bewertung = malloc(2*sizeof(int));
      bewerte(AlleMoeglichkeiten[ort], Set[i],bewertung);
      if((bewertung[0] == 4) & (bewertung[1] == 0))
        {
        return 1;
        }
      free(bewertung);
      }
    }
      return 0;
}


/**
* Diese Methode bekommt einen Tipp und eine Bewertung. Er rechnet daraufhin
* aus wie viele Mglichkeiten dann berbleiben, um so eine qualitative Bewertung,
* wie gut der Tipp ist, mglich zu machen.
*/
int bewerteMitfolgendemErgebnis( int ort, int w, int s, int **Set,int **AlleMoeglichkeiten)
{
  int score = 0;
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
    {
    if(Set[i][0] != -1)
      {
      int *bewertung;
        bewertung = malloc(2*sizeof(int));
      bewerte(AlleMoeglichkeiten[ort], Set[i],bewertung);
      if((bewertung[0] != s) | (bewertung[1] != w))
        {
        score = score + 1;
        }
      free(bewertung);
      }
    }
  return score;
}


