/*
*Dieses Programm wurde im Rahmen des Praktikums Paralleles Programmieren 
*geschrieben. Es implementiert einen Algorithmus zum Lösen von Mastermind,
*der abstrakt von Donald E. Knuth beschrieben wurde.
*Gestartet wird das Programm ohne Parameter um alle Codes durchzugenen,
*oder mit einer Repräsentation vom Code als 4 Zahlen.
*Autoren sind Nicole Tänzer und Fabian Fiedler
*/


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define ARRAY_SIZE 1296


int bewerte(int*,int*,int*);
int erstelleListe(int**);
int Loeser(int*, int*);
int entferne(int**, int* , int* );
int istSchwarzMoeglich(int, int**, int**);
int bewerteMitfolgendemErgebnis( int, int, int, int**,int**);
int berechnenaechstenTipp(int**, int**,int*, int*);

/**
*Main Methode, speichert die Eingabe, laesst sich dann die 
*MoeglichenErgebnisse berechnen und startet danach den Loeser.
*Entweder ohne Parameter um alle Codes durchzugenen oder mit einer 
*Repräsentation vom Code als 4 Zahlen starten.
**/
int main(int argc, char *Eingabe[])
{
  clock_t prgstart, prgende; //Definierung der Variablen
	prgstart=clock(); //CPU-Zeit zu Beginn des Programmes

  if(argc==5)
  {      
    int *loesung;
      loesung = malloc(4 * sizeof(int));
    loesung[0]=(*Eingabe[1]-48);
    loesung[1]=(*Eingabe[2]-48);
    loesung[2]=(*Eingabe[3]-48);
    loesung[3]=(*Eingabe[4]-48);
    int *erg;
    erg= malloc(6*sizeof(int));
    int anzahl = Loeser(loesung,erg);

    printf("Loesung = %d %d %d %d Anzahl = %d",erg[0],erg[1],erg[2],erg[3],anzahl);
    free(erg);
    free(loesung);
  }
  else
  {
      int *liste;
    liste = malloc(ARRAY_SIZE * sizeof(int));
    int i;
    int *gesamterg;
    gesamterg=malloc(6*sizeof(int));
    int **AlleErgebnisse;
    AlleErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));
    int k;
    for (k=0;k< ARRAY_SIZE;k++)
      {AlleErgebnisse[k]=malloc(4*sizeof(int));}
    erstelleListe(AlleErgebnisse);
    for(i=0;i < ARRAY_SIZE; i++)
    {
      int *loesung;
      int *erg;
      erg= malloc(6*sizeof(int));
      loesung = malloc(4 * sizeof(int));
      loesung[0]=AlleErgebnisse[i][0];
      loesung[1]=AlleErgebnisse[i][1];
      loesung[2]=AlleErgebnisse[i][2];
      loesung[3]=AlleErgebnisse[i][3];
      int a = Loeser(loesung,erg);
      liste[i] = a;
      free(erg);
      free(loesung);
    }
  int d=0;
  int e = 0;
  for(k=1;k < 9;k++)
  {
    printf("\n Folgende Zahlen brauchen %d Versuche :\n", k );
    for(i= 0; i<ARRAY_SIZE;i++)
      {
      if(liste[i]==k)
      {
        e = e + k;
      d++;
      printf("%d%d%d%d,",AlleErgebnisse[i][0],AlleErgebnisse[i][1],AlleErgebnisse[i][2],AlleErgebnisse[i][3]);
      }
      }
    printf("\n");
  } 
  printf("Durschnitlich %f Versuche.", ((1.0 * e)/d));
   free(gesamterg);
   free(liste);
  }
  prgende=clock();//CPU-Zeit am Ende des Programmes
  printf("Laufzeit %.2f Sekunden\n",(float)(prgende-prgstart) / CLOCKS_PER_SEC);
  return 0;
}


/**
* Versucht das Problem zu loesen, indem es Knuths Algorithmus anwendet. Benoetigt 
*die Loesung nur als Abbruchbedingung.
**/
int Loeser(int *loesung, int *erg)
{
  int **MoeglicheErgebnisse;
  MoeglicheErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));
  int i;
  for (i=0;i< ARRAY_SIZE;i++)
    {MoeglicheErgebnisse[i]=malloc(4*sizeof(int));}
  erstelleListe(MoeglicheErgebnisse);
  int **AlleErgebnisse;
  AlleErgebnisse = malloc(ARRAY_SIZE*sizeof(int*));
  int k;
  for (k=0;k< ARRAY_SIZE;k++)
    {AlleErgebnisse[k]=malloc(4*sizeof(int));}
  erstelleListe(AlleErgebnisse);
  int *bewertung;
    bewertung = (int *) calloc( 4, sizeof(int));
  int *naechsterTipp;
    naechsterTipp= (int *) malloc( 4 * sizeof(int));
  int *letzterTipp;
    letzterTipp = (int *) malloc( 4* sizeof(int));
  int anzahl=1;

  naechsterTipp[0]=1;
  naechsterTipp[1]=1;
  naechsterTipp[2]=2;
  naechsterTipp[3]=2;
  bewerte(loesung,naechsterTipp, bewertung);         
    //Die Abbruchbedingung, dass der Tipp Richtig ist.   
  while (bewertung[0] != 4)
    {
    entferne(MoeglicheErgebnisse,naechsterTipp, bewertung);
    berechnenaechstenTipp(MoeglicheErgebnisse,AlleErgebnisse,bewertung,naechsterTipp);
    bewerte(loesung,naechsterTipp,bewertung);
    anzahl++;
    }
  erg[0]=naechsterTipp[0];
  erg[1]=naechsterTipp[1];
  erg[2]=naechsterTipp[2];
  erg[3]=naechsterTipp[3];
  free(bewertung);
  free(naechsterTipp);
  free(letzterTipp);
 for (i=0;i<ARRAY_SIZE;i++)
  {free(MoeglicheErgebnisse[i]);}

  for (i=0;i<ARRAY_SIZE;i++)
    {free(AlleErgebnisse[i]);}
  free(MoeglicheErgebnisse);
  free(AlleErgebnisse);
  return anzahl;
}

/**
 *Berchnet die Anzahl weisser und farbiger Stifte der Eingabe im Vergleich zum Loesungsvorschlag
 **/
int bewerte(int *eingabe,int *loesungsVorschlag, int *erg)
{
  int schwarz=0;
  int weiss=0;
  int i;
  int Temp[4];
  for(i=0; i <=3; i++)
   {Temp[i]=eingabe[i];}
  for(i=0; i <= 3; i++)
  {
   if(Temp[i]==loesungsVorschlag[i])
   {
      schwarz = schwarz + 1;
      Temp[i] = -1;
   }
   int k;
   for(k = 0; k <= 3; k++)
   {
    if((k != i) & (Temp[i]==loesungsVorschlag[k]))
      {
      weiss = weiss +1;
      break;
      }
    }
  }
  erg[0]=schwarz;
  erg[1]=weiss;
  return 0 ;
}
/**
* Erstellt die Liste aller Moeglichen Ergebnisse.
**/
int erstelleListe(int **MoeglicheErgebnisse)
{
  int i;
  for(i = 0; i<6;i++)
    {
    int k;
    for(k = 0; k <6; k++)
      {
      int j;
      for( j = 0; j <6; j++)
        {
        int m;
        for( m = 0; m <6; m++)
        {
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][0]=m;
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][1]=j;
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][2]=k;
          MoeglicheErgebnisse[m+j*6+k*36+i*36*6][3]=i;
          }
        }
      }
    }
  return 0;
}


/**
* Entfernt alle nicht mehr möglichen Codes, Berechnung siehe Praktikumsbericht.
**/
int entferne(int **Set, int *Tipp, int *bewTipp)
{
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
    {
      int *bewertung;
      bewertung = malloc(2*sizeof(int));
      bewerte(Set[i], Tipp ,bewertung);
      if((bewertung[0] != bewTipp[0]) | (bewertung[1] != bewTipp[1]))
        {
        Set[i][0]= -1;
        }
      free(bewertung);
    } 
  return 0;
}
 int berechnenaechstenTipp(int **Set, int **AlleMoeglichkeiten,int *bewertungLetzterTipp, int *erg)
{
  int gesamterScore=0;
  int ortgesamterScore=0;
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
   {
    int minScore = ARRAY_SIZE;
    int w;
    for(w=0; w <= 4; w++)
      {
      int s;
      for(s = 0; s <= 4; s++)
        {
        if((w+ s) > 4) break;
        int score = bewerteMitfolgendemErgebnis(i,w,s,Set,AlleMoeglichkeiten);
        if(score < minScore)
          {
          minScore = score;
          }
        }
      }
    if((minScore > gesamterScore) | ( (minScore == gesamterScore )& ( istSchwarzMoeglich(i,Set,AlleMoeglichkeiten) == 1)))
      {
      gesamterScore=minScore;
      ortgesamterScore=i;
      }
    }
  erg[0] = AlleMoeglichkeiten[ortgesamterScore][0];
  erg[1] = AlleMoeglichkeiten[ortgesamterScore][1];
  erg[2] = AlleMoeglichkeiten[ortgesamterScore][2];
  erg[3] = AlleMoeglichkeiten[ortgesamterScore][3];
  return 0;
}

int istSchwarzMoeglich(int ort, int **Set, int **AlleMoeglichkeiten)
{
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
    {
    if(Set[i][0] != -1)
      {
      int *bewertung;
        bewertung = malloc(2*sizeof(int));
      bewerte(Set[ort], Set[i],bewertung);
      if((bewertung[0] == 4) & (bewertung[1] == 0))
        {
        return 1;
        }
      free(bewertung);
      }
    }
      return 0;
}

int bewerteMitfolgendemErgebnis( int ort, int w, int s, int **Set,int **AlleMoeglichkeiten)
{
  int score = 0;
  int i;
  for(i=0; i < ARRAY_SIZE; i++)
    {
    if(Set[i][0] != -1)
      {
      int *bewertung;
        bewertung = malloc(2*sizeof(int));
      bewerte(AlleMoeglichkeiten[ort], Set[i],bewertung);
      if((bewertung[0] != s) | (bewertung[1] != w))
        {
        score = score + 1;
        }
      free(bewertung);
      }
    }
  return score;
}
